import rospy
from .skill_interface import *


class SkillsSet:

    def __init__(self, **kwargs):
        self.__skills = []
        {% for s in skills %}
        self.__{{ s.name }} = {{ s.name|action_name }}Interface(**kwargs)
        self.__skills.append(self.__{{ s.name }})
        {%- endfor %}

    {% for s in skills %}
    @property
    def {{ s.name }}(self) -> {{ s.name|action_name }}Interface:
        return self.__{{ s.name }}
    {% endfor %}

    def __len__(self):
        return len(self.__skills)

    def __nonzero__(self):
        return len(self.__skills) > 0

    def __iter__(self):
        return iter(self.__skills)

    def __getitem__(self, item):
        return getattr(self, item)
        